"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runSteps = runSteps;
exports.runInTry = runInTry;
const Result_1 = require("../Result");
function runSteps(steps) {
    return __awaiter(this, void 0, void 0, function* () {
        let result = new Result_1.Result();
        for (const step of steps) {
            result = yield step(result);
        }
        return result;
    });
}
function runInTry(func_1, prev_1) {
    return __awaiter(this, arguments, void 0, function* (func, prev, ignoreException = false) {
        try {
            yield func();
            return true;
        }
        catch (err) {
            if (!ignoreException)
                prev.setError(err);
            return false;
        }
    });
}
